import 'types.dart';

class MapSanitizer {
  final Map<dynamic, List<Sanitizer>> mapSanitizers;

  const MapSanitizer(this.mapSanitizers);

  void sanitize(Map<dynamic, dynamic> map) {
    final keys = mapSanitizers.keys;
    for (int i = 0; i < keys.length; ++i) {
      final key = keys.elementAt(i);
      if (map.containsKey(key)) {
        final sanitizers = mapSanitizers[key]!;
        for (int j = 0; j < sanitizers.length; ++j) {
          map[key] = sanitizers[j].call(map[key]);
        }
      }
    }
  }
}
