import 'types.dart';

class MapValidator {
  final Map<dynamic, List<Validator>> mapValidators;

  const MapValidator(this.mapValidators);

  String? validate(Map<dynamic, dynamic> map) {
    final keys = mapValidators.keys;
    for (int i = 0; i < keys.length; ++i) {
      final key = keys.elementAt(i);
      if (map.containsKey(key)) {
        final validators = mapValidators[key]!;
        for (int j = 0; j < validators.length; ++j) {
          final error = validators[j].call(map[key]);
          if (error != null) {
            return error;
          }
        }
      }
    }
    return null;
  }
}
